package strategy;

import game.Game;
import game.Strategy;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.lang.Process;


/**
 * UNTESTED: there is something about this class that doesn't seem
 * to be working.
 * @author maz
 *
 */
public class FeedStrategy implements Strategy{
  public static String command="cut -f 1 -d ' '";
  
  public PrintStream out;
  public BufferedReader br;
  
  public FeedStrategy(Game g, long seed, String options) throws IOException{
    Runtime r = Runtime.getRuntime();
    Process p = r.exec(command);
    InputStream in = p.getInputStream();
    out = new PrintStream(p.getOutputStream());
    br = new BufferedReader(new InputStreamReader(in));
  }
  @Override
  public int getAction() {
    try{
      String line = br.readLine();
      System.out.println("Line received:"+line);
      int action = Integer.parseInt(line);
      return action;
    } catch (IOException io){
      io.printStackTrace(System.err);
    }
    return 0;
  }

  public static String arrayToSimpleString(int[] actions){
    if (actions.length==0){
      return "";
    }
    String result = ""+actions[0];
    for(int i=1;i<actions.length;i++){
      result+=" "+actions[i];
    }
    return result;
  }
  
  @Override
  public void observeOutcome(int[] actions) {
    String output  = arrayToSimpleString(actions);
    out.println(output);
    //System.out.println("Line given:"+output);
    out.flush();
  }

  public static void main(String[] args) throws IOException{
    FeedStrategy strategy = new FeedStrategy(null,0,"");
    strategy.out.println("0");
    strategy.out.flush();
    for(int i=0;i<10;i++){
      int action = strategy.getAction();
      strategy.observeOutcome(new int[]{i+1,action,0});
    }
  }
}
